/*
Copyright (c) 2008-2010 Nokia Corporation and/or its subsidiary(-ies). All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright notice, this
 list of conditions and the following disclaimer.
* Redistributions in binary form must reproduce the above copyright notice,
 this list of conditions and the following disclaimer in the documentation
 and/or other materials provided with the distribution.
* Neither the name of Nokia Corporation nor the names of its contributors
 may be used to endorse or promote products derived from this software
 without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

Description: 
*/


#ifndef CCOLLECTOR_H_
#define CCOLLECTOR_H_


#include <e32base.h>
#include <e32cons.h>
#include "e32std.h"
#include "e32msgqueue.h" 
#include "CMsgQActive.h"
/*This Class is used to get user input from the console and display the final output
 * to the user.
 */
class CCollector : public CActive
{
public:
 enum TRequestType {ECount, EStop} ;

public: 
 static CCollector* NewL(TInt aPriority = EPriorityStandard);
 CCollector(TInt aPriority = EPriorityStandard );
 virtual void DoCancel(); 
 virtual void RunL(); 
 void RequestFunction();
 void Stop();
 CCollector();
 virtual ~CCollector();
 void ConstructL();
 void ProcessKeyPress(TChar aChar);
 void StartRecieving();
 void SendMsgInQ(TBuf<100>);
private:
	TBuf<100> iBuf; //buffer to store words.
	CMsgQActive* iRcvInverterInQ;
	
	RMsgQueue<TBuf<100> > iInverterInQ;		  //message queues to be created and used to send data to inverter. 
	RMsgQueue<TBuf<100> > iInverterOutQ;		  //message queues to be created and used to recieve data from inverter. 
	RProcess process; //Inverter process.
	CConsoleBase* iConsole;
};

GLDEF_C TInt E32Main();

#endif /*CCollector_H_*/
